#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m, q;
    cin >> n >> m;
    int r(2 * n + m);
    bool b(false);
    vector<int> u(2 * n + m, -1);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> q;
        q--;
        a[i] = q;
    }
    for (int i = 0; i < n; i++) {
        cin >> q;
        q--;
        u[a[i]] = q;
        u[q] = -2;
    }
    for (int i = 0; i < m; i++) {
        cin >> q;
        q--;
    }
    for (int i = 2 * n + m - 1; i >= 0; i--) {
        if (u[i] == -2) {

        } else if (u[i] == -1) {
            b = !b;
        } else if (u[i] > r) {
            b = !b;
        } else {
            b = false;
            r = i;
        }
    }
    if (b) {
        cout << "Second" << endl;
    } else {
        cout << "First" << endl;
    }
}
